/*
* OPEN HARDWARE FOR HIGH SCHOOL (OH4HS) COURSE
* 
*
* 1. Στοιχεία Κώδικα
*    Ονομα εργασίας         : Quiz Game
*    Όνομα Αρχείων          : QuizGame.info
*    Επόπτης                : Δρ. Φωτόπουλος Βασίλειος, ΣΕΠ Ψ.Σ. Ε.Α.Π.
*    Συντάκτες              : Φωτιάδης Κώστας εκπ/κος ΠΕ17.07 (fotiadisk@sch.gr), Κουρτίδης Βαγγέλης εκπ/κος ΠΕ20, Ψώμος Βασίλης εκπ/κος ΠΕ19 
*    Ομάδα Εργασίας         : ΕΠΑ.Λ. Γέρας
*    Προσομοίωση παιχνιδιού : https://123d.circuits.io/circuits/1423275 
*    Ημ/νια δημιουργίας     : 27/12/2015
*         Έκδοση Κώδικα     : This template is version Revision: 1.0
*
* 2. Περιγραφή λειτουργίας
* 
* Ο κώδικας αυτός αποτελεί αναπόσπαστο μέρος ενός διδακτικού σεναρίου για μαθητές ΕΠΑ.Λ. που εκπονήθηκε στα πλαίσια του σεμιναρίου OPEN HARDWARE FOR HIGH SCHOOL (OH4HS) COURSE
* του Ελληνικού Ανοικτού Πανεπιστήμιου.
*
* Ο κώδικας υλοποιεί ένα παιχνίδι γνώσεων και ταχύτητας (Quiz Game). 
* Σκοπός του παιχνιδιού είναι να αναδειχθεί νικητής, αυτός που θα δώσει τις περισσότερες σωστές απαντήσεις. 
* Ο Συντονιστής απευθύνει μία σειρά ερωτήσεων  προς τους Παίκτες που καλούνται να δώσουν τις σωστές απαντήσεις, αφού πρώτα κερδίσουν την προτεραιότητα στην απάντηση,
* πατόντας το μπουτόν που έχουν μπροστά τους. Για κάθε σωστή απάντηση οι Παίκτες κερδίζουν 10 πόντους. 
* 
* Η λειτουργία του παιχνιδιού που υλοποιεί ο παρόν κώδικας περιγράφεται ως εξής: 
* 1. Το Quiz Game προορίζεται για την χρήση του από τρεις (3) Παίκτες (players), και έναν (1) παρουσιαστή (master). 
*    (Υπάρχει η δυνατότητα επέκτασης του κώδικα για χρήση από 4 Παίκτες)
* 
* 2. Το παιχνίδι χρησιμοποιεί δέκα συνολικά I/O pins του Arduino: 
*    α) Τα έξι xρησιμοποιούνται ως εισόδοι για τα buttons των παιχτών  και του παρουσιαστή. Στον κώδικα υλοποιείται και ο αποκλιδωνισμός λειτουργίας των μπουτόν (software debouncing)
*    β) Τα τέσσερα xρησιμοποιούνται ως εξόδοι για την οδήγηση τρίων led (ένα για κάθε Παίκτη) και ενός βομβητή (buzzer) ηχητικής σήμανσης.
*
* 3.  Οι τρεις Παίκτες έχουν μπροστά τους από ένα μπουτόν (button) και μια ενδεικτική λυχνία (LED) συγκεκριμένου χρώματος. 

* 4.  O Συντονιστής έχει μπροστά του τρια μπουτόν:
*     α) το πρωτεύον μπουτόν (primary button), β) το δευτερεύον μπουτόν 1 (secondary button 1) και γ) το δευτερεύον μπουτόν 2 (secondary button 2)
*
* 5. Στο παιχνίδι υπάρχει μια ηχητική σήμανση (buzzer) που ενεργοποιείται με διαφορετικούς ήχους ανάλογα με την ροή του παιχνιδιού.
*
* 6.  Κατά την ροή του παιχνιδιού εμφανίζονται επίσης μηνύματα που αφορούν την εξέλιξη του, χρησιμοποιόντας μια σειριακή οθόνη ενός υπολογιστή. 
*     ( Η επικοινωνία του Arduino με τον υπολογιστή πραγματοποιείται, συνδέοντας το arduino σε μια σειριακή θύρα USB του υπολογιστή)
*     ( Με επέκταση-τροποποίηση του κώδικα, τα μυνήματα μπορούν να στέλνοναι σε μια σειριακή LCD οθόνη)
* 
* 7.  Ο Συντονιστής εκφωνεί μια ερώτηση καλώντας τους τρεις Παίκτες να απαντήσουν, αφού πρώτα πατήσουν τα μπουτόν για να κερδίσουν την προτεραιότητα στην απάντηση.
*
* 8.  Ο πρώτος που θα πατήσει το μπουτόν, κατοχυρώνει το δικαίωμα να απαντήσει, ενώ ταυτόχρονα ακούγεται η ηχητική ειδοποίηση για το "κλείδωμα" της ερώτησης 
*     και ανάβει το LED που έχει μπροστά του. Τα μπουτόν των υπόλοιπων παιχτών σε αυτό το σημείο "κλειδώνουν" και δεν μπορούν να δώσουν καμία εντολή. 
*    
* 9. Τα μπουτόν των παιχτών μπορούν να "ξεκλειδώσουν" μόνο από τον παρουσιαστή, με την χρήση των τριών μπουτόν που έχει μπροστά του: 
*     
*     9.1) Αρχικά ο Συντονιστής, πατώντας το πρωτεύον μπουτόν,  δίνει την εντολή να εμφανιστεί στην οθόνη μύνημα με τον αριθμό του Παίκτη για τον οποίο έχει "κλειδώσει" η ερώτηση: 
*            α) To μήνυμα που εμφανίζεται είναι: "The Answer of Player (x) is:",  (όπου (χ) ο αριθμός του Παίκτη)
*            β) Ταυτόχρονα δίνεται ο απαραίτητος χρόνος για να ελεγχθεί αν η απάντηση που έδωσε ο Παίκτης είναι ΣΩΣΤΗ (RIGHT) ή ΛΑΘΟΣ (WRONG):
*  
*        9.1.1) Αν η απάντηση είναι σωστή, τότε πρέπει να πατήσει το δευτερεύον μπουτόν 1. Σε αυτό το στάδιο  το παιχνιδιού: 
*                  α) δίνονται δέκα (10) πόντοι στον Παίκτη που απάντησε σωστά.
*                  β) ακούγεται η ηχητική ειδοποίηση για την σωστή απάντηση.
*                  γ) στην οθόνη εμφανίζεται το μήνυμα "RIGHT, The total players' points are: (y), (όπου (y) είναι οι συνολικοί πόντοιτου Παίκτη  στο παιχνίδι)
*                  δ)  σβήνουν τα ενδεικτικά LED ,"ξεκλειδώνουν" τα μπουτόν όλων των παιχτών και το παιχνίδι συνεχίζεται με την επόμενη ερώτηση.           
*        
*       9.1.2) Αν η απάντηση είναι λάθος τότε πρέπει να πατήσει το δευτερεύον μπουτόν 2. Σε αυτό το στάδιο ο αυτοματισμός είναι ίδιος με αυτόν  που περιγράφεται στην ενότητα 9.1.1,
*              με την διαφορά ότι δεν δίνονται πόντοι στον Παίκτη, ακούγεται η ηχητική ειδοποίηση της λάθος απάντησης  
*              και εμφανίζεται στην οθόνη το μήνυμα: "WRONG", The total players' points are: (y)"
*
* 10.  Όταν ολοκληρωθεί το παιχνίδι των ερωτήσεων, ο Συντονιστής πρέπει να πατήσει δύο (2) φορές το πρωτεύον μπουτόν. 
*      Σε αυτό το σημείο στην οθόνη θα εμφανιστεί ένα μήνυμα με τον συνολικό αριθμό των πόντων που συγκέντρωσε ο κάθε Παίκτης και την αναγγελία του τέλους του παιχνιδιού. 
*      Μετά από αυτό το σημείο το Quiz Game είναι έτοιμο να αρχίσει έναν νέο γύρο παιχνιδού, αρχικοποιώντας (κάνοντας reset) όλες τις παραμέτρους του παιχνιδιού.
* 
* Περισσότερες πληροφορίες για την διαρρύθμιση του Quiz Game και το υλικό του μέρος περιγράφονται αναλυτικά στο διδακτικό σενάριο της εργασίας. 
*                     
*
* 3. Ιστορικό αλλαγών (latest version on top of the list)
*---------------------------------------------------------------------------------------------------
*    version: $Revision: 1.0 $
*    date modified: $Date: 
*    derived by: $Author: kfotiad $
*    Status: $State: Exp $ 
*    Version notes:
*    - $Log: 
*    - Revision 1.0  15-01-2016 14:41:02  kfotiad
*    - *** empty log message ***
*    -
*---------------------------------------------------------------------------------------------------
*/

// Make sure the file pitches.h is placed in the same folder as this sketch
#include "pitches.h"


#define DEBOUNCE 10  // // the debounce time; increase if the output flickers; in ms, 5+ ms usually is sufficient. 
 
// definition of the pins used as inputs
// The first three pins corespond to the buttons of the players, while the next three to the buttons of the game master. 
int buttons[] = {0, 1, 2, 4, 5, 6}; 
 
// definition of the total number of the buttons used in the game.
#define NUMBUTTONS sizeof(buttons)/2

// definition of the Master's buttons used in the game.
#define NUMBER_OF_MASTERBUTTONS 3;
// definition of the game points for the RIGHT answer to a question.
#define POINTS_FOR_RIGHT_QUESTION 10;
// the number of the players in the game.
const int numberOfPlayers = NUMBUTTONS - NUMBER_OF_MASTERBUTTONS;
 
// dedinition of the arrays used to identify the button that has just been pressed, just released or is currentry pressed. 
int justpressed[NUMBUTTONS], justreleased[NUMBUTTONS], pressed[NUMBUTTONS];
int previous_keystate[NUMBUTTONS], current_keystate[NUMBUTTONS];

// Array with the players' points of the game
int playersPoints[numberOfPlayers];

// definition of the pins used as ouptuts for driving the three LEDs' of the game.
int leds[] = {7, 8, 9};
/// definition of the total number of the LEDs' used in the game. 
#define NUMLEDS sizeof(leds)/2

// Global flags of the code
int primaryMasterButtonPresed =0;


bool playerButtonLock = false; // true : Priority is locked by some player or by the master
                               // false: Ppriority unlocked
bool secondaryMasterButtonPresed = false;

int priorityPlayer = 0; // Identification index of the player who gained the priority to answer the question

// Piezzo element connected to Arduino pin 11 and ground
const int buzzerPin = 11;

// Melody used for Game entrance
// Array with the notes in the melody (see pitches.h for reference)
int melody_starWars[] = {NOTE_A4, NOTE_A4, NOTE_A4, NOTE_F4, NOTE_C5, NOTE_A4, NOTE_F4, NOTE_C5, NOTE_A4, NOTE_E5, NOTE_E5, NOTE_E5, NOTE_F5, NOTE_C5, NOTE_A4, NOTE_F4, NOTE_C5, NOTE_A4};

// Array with note duration: 1 = whole note, 2 = half note, 4 = quarter note, 8 = eighth note, etc.
int noteDurations_starWars[]  = {4, 4, 4, 8, 16, 4, 8, 16, 2, 4, 4, 4, 8, 16, 4, 8, 16, 2};

// Sound used to indicate that the quiestion to answer has locked by some player
int melody_fasterPlayer[] = {NOTE_C4};
int noteDurations_fasterPlayer[] = {8};

// Sound used to indicate that the enswer to the quiestion is RIGHT
int melody_rightAnsw[] = {NOTE_F4, NOTE_F5};
int noteDurations_rightAnsw[] = {8, 8};

// Sound used to indicate that the enswer to the quiestion is WRONG
int melody_wrongAnsw[] = {NOTE_C3, NOTE_A2};
int noteDurations_wrongAnsw[] = {8, 8};

int tempo = 120; // tempo for the melody expressed in beats per minute (BPM)

void setup() {
  
  SetupInterfaceForMsg();
  defineButtonsInputsAndSetHIGH();
  resetPlayersPoints();
 
 // The function's parameter is boolean: 
 // 0->define the pins used as LED outputs and set pin ouputs to LOW, 1->only set pin ouputs to LOW
  defineLedPinsAndSetOFF(0); 
  
  priorityPlayer = 0;

  // Play the introductory melody of the game
  playTune(melody_starWars, noteDurations_starWars,sizeof(melody_starWars), tempo);
  digitalWrite(buzzerPin, LOW);
  delay(1000);
}
 
void loop() {
  
  int thisSwitch=thisSwitch_justPressed();
  
  switch(thisSwitch)
  {  
  case 0: // Player 1 pressed the button first
    
    if(playerButtonLock == false){
      
      setLedPinON(thisSwitch);
     
      priorityPlayer = thisSwitch+1;
      playerButtonLock = true; // The priority is granded to the Player 1. The buttons of the other players are locked until the Master releases them.   

     // Play sound to indicate that the priority is locked
      playTune(melody_fasterPlayer, noteDurations_fasterPlayer,sizeof(melody_fasterPlayer), tempo);
      digitalWrite(buzzerPin, LOW);
      delay(200);  
    }
    break;
  case 1: // Player 2 pressed the button first
   
    if(playerButtonLock == false){
      
      setLedPinON(thisSwitch);
      
      priorityPlayer = thisSwitch+1;
      playerButtonLock = true; // The priority is granded to the Player 1. The buttons of the other players are locked until the Master releases them.  

      // Play sound to indicate that the priority is locked
      playTune(melody_fasterPlayer, noteDurations_fasterPlayer,sizeof(melody_fasterPlayer), tempo);
      digitalWrite(buzzerPin, LOW);
      delay(200);
    }
    break;
  
  case 2: // Player 3 pressed the button first   
   
    if(playerButtonLock == false){

      setLedPinON(thisSwitch);
     
      priorityPlayer = thisSwitch+1;
      playerButtonLock = true; // The priority is granded to the Player 1. The buttons of the other players are locked until the Master releases them. 

      // Play sound to indicate that the priority is locked
      playTune(melody_fasterPlayer, noteDurations_fasterPlayer,sizeof(melody_fasterPlayer), tempo);
      digitalWrite(buzzerPin, LOW);
      delay(200);
    }
    break;
    
  case 3: // Master's Primary Button 
  
    playerButtonLock = true; // lock the buttons of the players
    primaryMasterButtonPresed =++primaryMasterButtonPresed; // counter of times the Master's primary button is pressed
                                                            // 0: the button is not pressed, 1: is prssed one time, 2: is prssed tow times  

    if((primaryMasterButtonPresed==1)&&(priorityPlayer)){
      
       ThePriorityPlayerMsg(priorityPlayer);
       secondaryMasterButtonPresed = false; 
    }
    else if((primaryMasterButtonPresed > 1)&&(!priorityPlayer)){
       primaryMasterButtonPresed =0; // reset the counter
       playerButtonLock = false; // unlock the buttons of the players
       priorityPlayer = 0; // reset the identification index of the player who gained the priority  

      totalPlayersPointsMsg(numberOfPlayers); // report of the players' points
      
      defineLedPinsAndSetOFF(1);
      resetPlayersPoints();
      
      startAgainMsg();
      // Play the introductory melody of the game
      playTune(melody_starWars, noteDurations_starWars,sizeof(melody_starWars), tempo);
      digitalWrite(buzzerPin, LOW);
      delay(200);
    }
    break;
 
  case 4: // Master's secontary  button 1, to accept RIGHT answares
   
    if((primaryMasterButtonPresed)&&(!secondaryMasterButtonPresed)){ 
     
     secondaryMasterButtonPresed = true;
     playerButtonLock = 0;
     primaryMasterButtonPresed = 0;
     
     theAnsweredQuestionIsMsg(thisSwitch);
     
     playTune(melody_rightAnsw, noteDurations_rightAnsw,sizeof(melody_rightAnsw), tempo);
     digitalWrite(buzzerPin, LOW);
     delay(200);

     defineLedPinsAndSetOFF(1);
     priorityPlayer = 0;
     
    }   
    break;
 
  case 5: // Master's secontary  button 1,to indicate WRONG answares
    if((primaryMasterButtonPresed)&&(!secondaryMasterButtonPresed)){ 
     
     secondaryMasterButtonPresed = true;
     playerButtonLock = 0;
     primaryMasterButtonPresed = 0;
     theAnsweredQuestionIsMsg(thisSwitch);

     playTune(melody_wrongAnsw, noteDurations_wrongAnsw,sizeof(melody_wrongAnsw), tempo);
     digitalWrite(buzzerPin, LOW);
     delay(200);

     defineLedPinsAndSetOFF(1);
     priorityPlayer = 0;     
    }
    break;
  }
}
 
void defineButtonsInputsAndSetHIGH(){

int i;
  // Make input & enable pull-up resistors on switch pins
  for (i=0; i< NUMBUTTONS; i++) {
    pinMode(buttons[i], INPUT);
    digitalWrite(buttons[i], HIGH);
    //if(i<numberOfPlayers) playersPoints[i]=0; // reset the points of each pleyer
  }
  delay(200);
}

void resetPlayersPoints(){

int i;
  // Make input & enable pull-up resistors on switch pins
  for (i=0; i< numberOfPlayers; i++) {
       playersPoints[i]=0; // reset the points of each pleyer
  }
}
 
void defineLedPinsAndSetOFF(byte defined ){

int i;
// Δημιουργία των εξόδων του παιχνιδιού 
   for (i=0; i< NUMLEDS; i++) {
   if(!defined) pinMode(leds[i], OUTPUT);
    digitalWrite(leds[i], LOW);
  }
  delay(200);
 }

void setLedPinON(int ledPinIndex){
  
  digitalWrite(leds[ledPinIndex], HIGH);
  delay(200);  
 }

void SetupInterfaceForMsg(){

   Serial.begin(9600); //set up serial port
   Serial.println("VOCATIONAL HIGH SCHOOL OF GERA, LESVOS");
   Serial.println("**********  THE QUIZ GAME  ***********");
   Serial.println(" ");
   delay(200);

}

void startAgainMsg(){
  
  Serial.println("****  The players points go back to zero  ****"); 
  Serial.println(" ");
  Serial.println("*** NEW ROUND OF THE QUIZ GAME IS STARTING ***"); 
  Serial.println(" ");
  delay(200);
}

void ThePriorityPlayerMsg(int player){
  
  Serial.print("The Answer of Player ");
  Serial.print(player);
  Serial.print(" is: "); 
  delay(200);
 }

void totalPlayersPointsMsg(int nbOfPlayers){
  
  int i;
  int Player = 0;
  int PlayerPoints = 0;
  
  Serial.println(" ");
  Serial.println("The total players' points are: "); 
  
  for (i=0;i<nbOfPlayers;i++){
    
    Player = i+1;
    PlayerPoints = playersPoints[i];
    Serial.print("Player "); 
    Serial.print(Player);
    Serial.print(": ");
    Serial.print(PlayerPoints);
    Serial.println("pts"); 
  }
  
  Serial.println(" ");
  delay(200);
 }

void theAnsweredQuestionIsMsg(int secondaryButton){
  
  int points;
  
  if(secondaryButton == 4){
      Serial.print("RIGHT, ");
      points = playersPoints[priorityPlayer-1]+POINTS_FOR_RIGHT_QUESTION;
      playersPoints[priorityPlayer-1]= points; 
      Serial.print(points);
      Serial.println("pts in total");
      delay(200);
  }
  else if (secondaryButton == 5){
      Serial.print("WRONG, ");
      points = playersPoints[priorityPlayer-1];
      Serial.print(points);
      Serial.println("pts in Total");
      delay(200);
  }
}

void check_switches()
{
  static int previousstate[NUMBUTTONS];
  static int currentstate[NUMBUTTONS];
  static long lasttime;
  int index;
  
  if (millis() < lasttime) {
    // we wrapped around, lets just try again
    lasttime = millis();
  }
  if ((lasttime + DEBOUNCE) > millis()) {
    // not enough time has passed to debounce
    return; 
  }
  // ok we have waited DEBOUNCE milliseconds, lets reset the timer
  lasttime = millis();
  for (index = 0; index < NUMBUTTONS; index++) {
    justpressed[index] = 0;       //when we start, we clear out the "just" indicators
    justreleased[index] = 0;
    currentstate[index] = digitalRead(buttons[index]);   //read the button
    if (currentstate[index] == previousstate[index]) {
      if ((pressed[index] == LOW) && (currentstate[index] == LOW)) {
        // just pressed
        justpressed[index] = 1;
      }
      else if ((pressed[index] == HIGH) && (currentstate[index] == HIGH)) {
        justreleased[index] = 1; // just released
      }
      pressed[index] = !currentstate[index];  //remember, digital HIGH means NOT pressed
    }
    previousstate[index] = currentstate[index]; //keep a running tally of the buttons
  }
}

int thisSwitch_justPressed() {
  
  int thisSwitch = 255;
  
  check_switches();  //check the switches &amp; get the current state
  
  for (byte i = 0; i < NUMBUTTONS; i++) {
    current_keystate[i]=justpressed[i];
    if (current_keystate[i] != previous_keystate[i]) {
      if (current_keystate[i]) thisSwitch=i;
    }
    previous_keystate[i]=current_keystate[i];
  }  
  return thisSwitch;
}

void playTune(int notes[], int durations[],int tuneSize, int BPM) 
{
  tuneSize = tuneSize / sizeof(int);
  
  // iterate over the notes of the tune:
  for (int thisNote = 0; thisNote < tuneSize; thisNote++) {

    // For details on calculating the note duration using the tempo and the note type,
    // see http://bradthemad.org/guitar/tempo_explanation.php.
    // A quarter note at 60 BPM lasts exactly one second and at 120 BPM - half a second.
    
    int noteDuration = (int)((1000 * (60 * 4 / BPM)) / durations[thisNote] + 0.);
    tone(buzzerPin, notes[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 20% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    //noTone(buzzerPin);
     digitalWrite(buzzerPin, HIGH);
  }
}

