/*
* OPEN HARDWARE FOR HIGH SCHOOL (OH4HS) COURSE
* 
*
* 1. Στοιχεία Κώδικα
*    Ονομα εργασίας         : Quiz Game
*    Όνομα Αρχείων          : QuizeGameCodeExercise.ino
*    Επόπτης                : Δρ. Φωτόπουλος Βασίλειος, ΣΕΠ Ψ.Σ. Ε.Α.Π.
*    Συντάκτες              : Φωτιάδης Κώστας εκπ/κος ΠΕ17.07 (fotiadisk@sch.gr), Κουρτίδης Βαγγέλης εκπ/κος ΠΕ20, Ψώμος Βασίλης εκπ/κος ΠΕ19 
*    Ομάδα Εργασίας         : ΕΠΑ.Λ. Γέρας
*    Προσομοίωση παιχνιδιού : https://123d.circuits.io/circuits/1423275 
*    Ημ/νια δημιουργίας     : 27/12/2015
*         Έκδοση Κώδικα     : This template is version Revision: 1.0
*
* 2. Περιγραφή λειτουργίας
* 
* Κωδικας για εξάσξηση πάνω στο υλικό μέρος του παιχνιδιού QuizGame
* 
*/


// Include library for I2C LCD messages diplay 
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

#define DEBOUNCE 10  // // the debounce time; increase if the output flickers; in ms, 5+ ms usually is sufficient. 
 
// definition of the pins used as inputs
// The first three pins corespond to the buttons of the players, while the next three to the buttons of the game master. 
int buttons[] = {0, 1, 2, 4, 5, 6}; 
// definition of the total number of the buttons used in the game.
#define NUMBUTTONS sizeof(buttons)/2

// definition of the pins used as ouptuts for driving the three LEDs' of the game.
int leds[] = {7, 8, 9};
/// definition of the total number of the LEDs' used in the game. 
#define NUMLEDS sizeof(leds)/2

// Piezzo element connected to Arduino pin 11 and ground
const int buzzerPin = 11;

// dedinition of the arrays used to identify the button that has just been pressed, just released or is currentry pressed. 
int justpressed[NUMBUTTONS], justreleased[NUMBUTTONS], pressed[NUMBUTTONS];
int previous_keystate[NUMBUTTONS], current_keystate[NUMBUTTONS];

/****** IC2 LCD Gloobal Parameters ******/
#define BACKLIGHT_PIN     13
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE); // set the LCD address to 0x27

void setup() {
  
  SetupInterfaceForMsg();
  //SetupI2cLcdInterfaceForMsg();
  defineButtonsInputsAndSetHIGH();
 
  // The function's parameter is boolean: 
  // 0->define the pins used as LED outputs and set pin ouputs to LOW, 1->only set pin ouputs to LOW
  defineLedPinsAndSetOFF(0); 
  
  delay(1000);
}
 
void loop() {

  int thisSwitch=thisSwitch_justPressed();
  
  switch(thisSwitch)
  {  
  case 0: // Button 1
    
       pressedButtonMsg(thisSwitch+1);
       //pressedButtonLCDMsg(thisSwitch+1);
       setLedPinON(thisSwitch);
       break;
  
  case 1: // Button 2
   
        pressedButtonMsg(thisSwitch+1);
        //pressedButtonLCDMsg(thisSwitch+1);
        setLedPinON(thisSwitch);
        break;
  
  case 2: // Button 3  
   
       pressedButtonMsg(thisSwitch+1);
       //pressedButtonLCDMsg(thisSwitch+1);
       setLedPinON(thisSwitch);
       break;
    
  case 3: // Button 4
      
        pressedButtonMsg(thisSwitch+1);
        //pressedButtonLCDMsg(thisSwitch+1);
        setLedPinOFF(0);
        break;
 
  case 4: // Button 5

        pressedButtonMsg(thisSwitch+1);
        //pressedButtonLCDMsg(thisSwitch+1);
        setLedPinOFF(1);
        break;
 
  case 5: // Button 6

        pressedButtonMsg(thisSwitch+1);
        //pressedButtonLCDMsg(thisSwitch+1);
        setLedPinOFF(2);
        break;

    default: break;
    
  }
}
 
void setLedPinON(int ledPinIndex){

  digitalWrite(leds[ledPinIndex], HIGH);
  delay(200);
 }

void defineLedPinsAndSetOFF(byte defined ){

int i;
// Δημιουργία των εξόδων του παιχνιδιού 
   for (i=0; i< NUMLEDS; i++) {
       if(!defined) pinMode(leds[i], OUTPUT);
       digitalWrite(leds[i], LOW);
   }
  delay(200);
 }

void setLedPinOFF(int ledPinIndex){

  digitalWrite(leds[ledPinIndex], LOW);
  delay(200);
 }

 void  SetupInterfaceForMsg(){

  Serial.begin(9600); //set up serial port
  Serial.println(" EPAL GERAS ");  
  Serial.println (" QUIZ GAME PROJECT ");
  Serial.println (" ");
  delay(200);
}

void pressedButtonMsg(int buttonNumber){

  Serial.print("The pressed button is: ");
  Serial.println(buttonNumber); 
  delay(200); 
}

void defineButtonsInputsAndSetHIGH(){

int i;
  // Make input & enable pull-up resistors on switch pins
  for (i=0; i< NUMBUTTONS; i++) {
      pinMode(buttons[i], INPUT);
      digitalWrite(buttons[i], HIGH);
      //if(i<numberOfPlayers) playersPoints[i]=0; // reset the points of each pleyer
  }
  delay(200);
}
 
 void SetupI2cLcdInterfaceForMsg(){

  // Switch on the backlight
  pinMode ( BACKLIGHT_PIN, OUTPUT );
  digitalWrite ( BACKLIGHT_PIN, HIGH );
  
  lcd.begin(20,4);               // initialize the lcd 
  lcd.home ();                   // go home
  lcd.print("     EPAL GERAS ");  
  lcd.setCursor ( 0, 1 );        // go to the next line
  lcd.print ("  QUIZ GAME PROJECT  ");
 }

void pressedButtonLCDMsg(int buttonNumber){

  lcd.setCursor(1,4); //Start at character 4 on line 0
  lcd.print("Pressed button: ");
  lcd.print(buttonNumber);
}
 
/*
void pressedButtonLCDMsg(int buttonNumber){
 int i;
 
 if(buttonNumber>3){
    lcd.setCursor(5,2);
    lcd.print( "time: " );
    lcd.setCursor(13,2);
    
    for (int i = 0; i < 6; i++) {
         lcd.setCursor(11,2);
         lcd.print(i);
         lcd.print( " sec" ); 
         delay(1000);
    }
    lcd.setCursor(5,2);
    lcd.print( "                " );
 }    
}
*/

void check_switches()
{
  static int previousstate[NUMBUTTONS];
  static int currentstate[NUMBUTTONS];
  static long lasttime;
  int index;
  if (millis() < lasttime) {
    // we wrapped around, lets just try again
    lasttime = millis();
  }
  if ((lasttime + DEBOUNCE) > millis()) {
    // not enough time has passed to debounce
    return; 
  }
  // ok we have waited DEBOUNCE milliseconds, lets reset the timer
  lasttime = millis();
  for (index = 0; index < NUMBUTTONS; index++) {
    justpressed[index] = 0;       //when we start, we clear out the "just" indicators
    justreleased[index] = 0;
    currentstate[index] = digitalRead(buttons[index]);   //read the button
    if (currentstate[index] == previousstate[index]) {
      if ((pressed[index] == LOW) && (currentstate[index] == LOW)) {
        // just pressed
        justpressed[index] = 1;
      }
      else if ((pressed[index] == HIGH) && (currentstate[index] == HIGH)) {
        justreleased[index] = 1; // just released
      }
      pressed[index] = !currentstate[index];  //remember, digital HIGH means NOT pressed
    }
    previousstate[index] = currentstate[index]; //keep a running tally of the buttons
  }
}

int thisSwitch_justPressed() {
  int thisSwitch = 255;
  check_switches();  //check the switches & get the current state
  for (byte i = 0; i < NUMBUTTONS; i++) {
    current_keystate[i]=justpressed[i];
    if (current_keystate[i] != previous_keystate[i]) {
      if (current_keystate[i]) thisSwitch=i;
    }
    previous_keystate[i]=current_keystate[i];
  }  
  return thisSwitch;
}

